Uninstalled snaps show most recent channel version, not version to be installed by default

Bug #1767445 reported by Adam Collard on 2018-04-27
20
This bug affects 2 people
Affects Status Importance Assigned to Milestone
snapd
Undecided
Unassigned
gnome-software (Ubuntu)
Medium
Unassigned
Xenial
Medium
Unassigned
Bionic
Medium
Unassigned
Cosmic
Medium
Unassigned

Bug Description

[Impact]
GNOME Software can show incorrect version of snap that will be installed on details page.

[Test Case]
1. Open GNOME Software. Ensure blender or spotify snap is not installed.
2. Select blender or spotify snap (tried 28-04-2018, may change if store versions are changed)

Expected result:
Version label shows version to be installed (stable channel by default)

Observed result:
Version label shows most recently uploaded version, i.e. from the edge channel. This is not the version that will be installed when clicking install.

[Regression Potential]
The logic around choosing which version value to show was changed. Could create other bugs with this data.

Orignial text:

Ubuntu Software, when showing metadata about a snap package, is most of the time, likely to get information which is misleading, since it shows info from the *most recently* uploaded snap, regardless of which channel the snap was uploaded to.

An example of this is to search for blender, and see that the version shows the edge channel - 2.80-4de142e0b7b and not the stable channel - 2.79.

After actually installing the application, the correct metadata is shown.

See https://forum.snapcraft.io/t/unexpected-revision-information-exposed-in-some-situations/5163 for more details.

Adam Collard (adam-collard) wrote :
Robert Ancell (robert-ancell) wrote :

Removing snapd-glib as that just reflects whatever snapd tells it. Adding snapd as it gets to decide what this field contains.

no longer affects: snapd-glib (Ubuntu)
Robert Ancell (robert-ancell) wrote :

Is there any other data apart from the version?

Changed in gnome-software (Ubuntu Bionic):
importance: Undecided → Medium
Changed in gnome-software (Ubuntu Cosmic):
importance: Undecided → Medium
Changed in gnome-software (Ubuntu Xenial):
status: New → Triaged
Changed in gnome-software (Ubuntu Bionic):
status: New → Triaged
Changed in gnome-software (Ubuntu Cosmic):
status: New → Triaged
Changed in gnome-software (Ubuntu Xenial):
importance: Undecided → Medium
Changed in gnome-software (Ubuntu Bionic):
status: Triaged → Fix Committed
summary: - Incorrect metadata shown for snaps
+ Uninstalled snaps show most recent channel version, not version to be
+ installed by default
Changed in gnome-software (Ubuntu Xenial):
status: Triaged → Fix Committed
Changed in gnome-software (Ubuntu Cosmic):
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gnome-software - 3.28.1-0ubuntu5

---------------
gnome-software (3.28.1-0ubuntu5) cosmic; urgency=medium

  * debian/patches/0011-Support-snap-channels.patch:
    - Fix incorrect default install version being shown (LP: #1767445)

 -- Robert Ancell <email address hidden> Thu, 03 May 2018 12:33:30 +1200

Changed in gnome-software (Ubuntu Cosmic):
status: Fix Committed → Fix Released
Łukasz Zemczak (sil2100) wrote :

Can this bug be updated to include the SRU relevant information?

description: updated
description: updated

Hello Adam, or anyone else affected,

Accepted gnome-software into bionic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/gnome-software/3.28.1-0ubuntu4.18.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-bionic to verification-done-bionic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-bionic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-needed verification-needed-bionic
Ads20000 (ads20000) wrote :

Tested gnome-software 3.28.1-0ubuntu4.18.04.1 with gnome-software-plugin-snap 3.28.1-0ubuntu4.18.04.1. The `blender` snap displays the correct version now (the stable release rather than the latest version), same for `intellij-idea-community`, `mumble`, etc...

tags: added: verification-done-bionic
removed: verification-needed-bionic
Brian Murray (brian-murray) wrote :

Hello Adam, or anyone else affected,

Accepted gnome-software into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/gnome-software/3.20.5-0ubuntu0.16.04.11 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-needed-xenial
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gnome-software - 3.28.1-0ubuntu4.18.04.1

---------------
gnome-software (3.28.1-0ubuntu4.18.04.1) bionic; urgency=medium

  * debian/patches/0011-Support-snap-channels.patch:
    - Fix incorrect default install version being shown (LP: #1767445)
    - Make snap channel selection list scrollable (LP: #1768779)
    - Fix channel branches all showing the same name (LP: #1768794)
    - Alphabetically sort channel branch names (LP: #1769556)
  * debian/control:
    - Use bionic Vcs link

 -- Robert Ancell <email address hidden> Mon, 07 May 2018 16:32:37 +1200

Changed in gnome-software (Ubuntu Bionic):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for gnome-software has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

SRU verification for Xenial:
I have reproduced the problem with gnome-software 3.20.5-0ubuntu0.16.04.10 in xenial-updates and have verified that the version of gnome-software 3.20.5-0ubuntu0.16.04.11 in -proposed fixes the issue.

Marking as verification-done

tags: added: verification-done verification-done-xenial
removed: verification-needed verification-needed-xenial
description: updated
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gnome-software - 3.20.5-0ubuntu0.16.04.11

---------------
gnome-software (3.20.5-0ubuntu0.16.04.11) xenial; urgency=medium

  * debian/patches/0019-Support-channels.patch:
    - Make snap channel selection list scrollable (LP: #1768779)
  * debian/patches/0020-Add-a-basic-permission-system.patch
  * debian/patches/0021-Add-a-Snap-plugin.patch
    - Correctly handle snap install/remove failures (LP: #1762427)
    - Fix snaps without icons not showing (LP: #1763736)
    - Add basic system for connecting/disconnecting snap interfaces
      (LP: #1597314)
    - Alphabetically sort channel branch names (LP: #1769556)
  * debian/patches/0050-snap-Support-channels.patch:
    - Fix incorrect default install version being shown (LP: #1767445)

 -- Robert Ancell <email address hidden> Tue, 08 May 2018 12:02:36 +1200

Changed in gnome-software (Ubuntu Xenial):
status: Fix Committed → Fix Released
Paweł Stołowski (stolowski) wrote :

I've check this with Chipaca, there is no plan to change anything in snapd wrt this bug on the following basis: (a) user can look at the channel map to know what's in stable, and (b) store can change what's returned outside the channel map, which snapd will forward on.

Changed in snapd:
status: New → Won't Fix
no longer affects: snapstore
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers